/*
QUSOFT MICROSYSTMES
1869

Classe: TGood - Type Good

Hirarchie:
TObject -> TGood
*/

/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * TItem class represents a 1869 tradeable good.
*/

#define Good_Adjective_Bale 0
#define Good_Adjective_Ton 1
#define Good_Adjective_Crate 2
#define Good_Adjective_Barrel 3

//Structure de l'objet de Type Good  extension de TObject
typedef struct Good  {
	char *class; 	//Le nom de la classe
	char *super; 	//Le nom de la superclasse
	struct Object*	(*clone)		(struct Object*);
	BOOL						(*equals)		(struct Object*, struct Object*);
	void						(*finalize)	(struct Good*);
	TString* 				(*toString) (struct Good*);
	TString* description;
	int adjective;
} TGood ;

//Dclaration des constructeurs
TGood* TGood0(char*, int);

//Dclaration des mthodes
void 			TGood_finalize		(TGood*);
TString*	TGood_toString		(TGood*);

/**
 * Ce constructeur instancie un objet de Type Item.
 @since Release 1.0
*/
TGood* TGood0 (char* description, int adjective) {

	TGood *this = (TGood*)malloc(sizeof(TGood));
	
	this->class  = "TGood";
	this->super  = "TObject";
	
	this->clone    = TObject_clone;
	this->equals   = TObject_equals;
	this->finalize = TGood_finalize;
	this->toString = TGood_toString;
	
	this->description = s(description);
	this->adjective 	= adjective;
	
	return this;
}

TString* TGood_toString	(TGood* this) {

	return c(this->description);
}

void TGood_finalize	(TGood* this) {
	
	this->description->finalize(this->description);
	free(this);
}