/*
QUSOFT MICROSYSTMES
1869

Classe: TPlayer - Type Player

Hirarchie:
TObject -> TPlayer
*/

/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * The TPlayer class represents a 1869's port.
*/

#define POLITIC_NA 5
#define POLITIC_STABLE 0
#define POLITIC_UNREST 1
#define POLITIC_REVOLTS 2
#define POLITIC_CIVIL_WAR 3
#define POLITIC_WAR 4

#define NO_REGION -1
#define AMERICA 0
#define EUROPE 1
#define AFRICA 2
#define ASIA 3

//Structure de l'objet de Type Port extension de TObject
typedef struct Port {
	char *class; //Le nom de la classe
	char *super; //Le nom de la superclasse
	struct Object* 	(*clone) 		(struct Object*);
	BOOL 						(*equals) 	(struct Object*, struct Object*);
	void 						(*finalize) (struct Port*);
	TString* 				(*toString) (struct Port*);
	TString* name;
	TString* country;
	int id;
	int politic;
	int x;
	int y;
	int geo;
	BOOL shipyard; //true if shipyard
	TString* shipyardName; //name of shipyard
	TVector* ships; //list of ships
} TPort;

//Dclaration des constructeurs
TPort* TPort0(char*, int);

//Dclaration des mthodes
TString* 	TPort_toString	(TPort*);
void		 	TPort_finalize	(TPort*);

/**
 * Ce constructeur instancie un objet de Type Port.
 @since Release 1.0
*/
TPort* TPort0 (char* name, int id) {
	TPort *this = (TPort*)malloc(sizeof(TPort));
	
	this->class  = "TPort";
	this->super  = "TObject";
	
	this->clone    = TObject_clone;
	this->equals   = TObject_equals;
	this->finalize = TPort_finalize;
	this->toString = TPort_toString;
	
	this->name = s(name);
	this->country = NULL;
	this->id = id;
	this->politic = POLITIC_NA;
	this->x = 0;
	this->y = 0;
	this->geo = NO_REGION;
	this->shipyard = FALSE;
	this->shipyardName = s("");
	this->ships = TVector0();
	
	return this;
}

TString* TPort_toString	(TPort* this) {
	TString *str0 = s(" ");
	TString *str1 = this->name->concat(this->name, s(" "));
	
	str0->finalize(str0);
	
	str0 = str1->concat(str1, this->country);
	
	str1->finalize(str1);

	return str0;
}

void TPort_finalize	(TPort* this) {
	
	this->name->finalize(this->name);
	if (this->country != NULL)
	{
		this->country->finalize(this->country);
	}
	this->shipyardName->finalize(this->shipyardName);
	this->ships->finalize(this->ships);
	free(this);
}
