/*
QUSOFT MICROSYSTMES
1869

Classe: TStock - Type Stock

Hirarchie:
TObject -> TStock
*/

/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * TStock class represents a stock possessed by a player.
*/

//Structure de l'objet de Type Stock extension de TObject
typedef struct Stock  {
	char *class; 	//Le nom de la classe
	char *super; 	//Le nom de la superclasse
	struct Object*	(*clone)		(struct Object*);
	BOOL						(*equals)		(struct Object*, struct Object*);
	void						(*finalize)	(struct Item*);
	TString* 				(*toString) (struct Item*);
	TGood* good;
	int quantity;
} TStock ;

//Dclaration des constructeurs
TStock* TStock0(TGood*, int);

//Dclaration des mthodes
void 			TStock_finalize		(TStock*);
TString*	TStock_toString		(TStock*);

/**
 * Ce constructeur instancie un objet de Type Stock.
 @since Release 1.0
*/
TStock* TStock0 (TGood* good, int quantity) {

	TStock *this = (TStock*)malloc(sizeof(TStock));
	
	this->class  = "TStock";
	this->super  = "TObject";
	
	this->clone    = TObject_clone;
	this->equals   = TObject_equals;
	this->finalize = TStock_finalize;
	this->toString = TStock_toString;
	
	this->good 		= good;
	this->quantity	= quantity;
	
	return this;
}

TString* TStock_toString	(TStock* this) {

	return this->good->toString(this->good);
}

void TStock_finalize	(TStock* this) {
	
	free(this);
}
