/*
QUSOFT MICROSYSTMES
C Object Oriented Language

Classe: TComponent - Type Component

Hirarchie:
TObject -> TComponent
*/

/**
 * La classe TComponent est la racine de la hirarchie des composants visuels.  Elle dfinie
 * les proprits communes  tous les objets visuels.
 @since Release 1.0
*/
public class TComponent extends TObject {
	/**La hauteur du composant*/
	public int height;  	
	/**L'image de la partie de l'cran cache par le composant*/
	public Object img;	
	/**La visibilit du composant*/
	public boolean visible; 
	/**La largeur du composant*/
	public int width;		
	/**La position horizontale du composant*/
	public int x;				
	/**La position verticale du composant*/
	public int y;				
	

/**
 * Ce constructeur instancie un objet de Type Component.
 @since Release 1.0
*/
public TComponent TComponent0 () {

	return new TComponent();
}

/**
 * Cette mthode retourne un objet de Type Component qui est une copie de l'objet.
 @return clone - Une copie de l'objet.
 @since Release 1.0
*/
public TComponent clone() {
	
	return new TComponent();
}

/**
 * Cette mthode compare l'objet  un autre objet pour tablir une galit.
 * Dans le cas d'un objet de Type Component, une comparaison est tablie
 * entre les proprits.
 @param component0 L'objet  comparer.
 @return result - Vrai si les deux objets sont gaux.
 @since Release 1.0
*/
public boolean equals (TComponent component0) {
	
	return false;
}

/**
 * Cette mthode libre l'espace mmoire occupe par l'objet, dtruisant ce dernier.
 @since Release 1.0
*/
public void finalize () {
}

/**
 * Cette mthode affiche le composant  l'cran.
 @since Release 1.0
*/
public void print() {
	
}

/**
 * Cette mthode dplace le composant vers de nouvelles coordones.
 @param x La position horizontale du composant
 @param y La position verticale du composant 
 @since Release 1.0
*/
public void move(int x, int y) {
}

/**
 * Cette mthode change la visibilit du composant.
 @param visible La visibilit du composant
 @since Release 1.0
*/
public void setVisible(boolean visible) {
}

/**
 * Cette mthode permet de spcifier l'espace occup par le composant.
 @param x0 La position horizontale du coin supprieur gauche
 @param y0 La position verticale du coin supprieur gauche
 @param x1 La position horizontale du coin infrieur droit
 @param y1 La position verticale du coin infrieur droit
 @since Release 1.0
*/
public void setBounds(int x0, int y0, int x1, int y1) {
}

/**
 * Cette mthode change la hauteur du composant
 @param height La hauteur du composant
 @since Release 1.0
*/
public void setHeight(int height) {
}

/**
 * Cette mthode change la largeur du composant
 @param width La largeur du composant
 @since Release 1.0
*/
public void setWidth(int width) {
}

/**
 * Cette mthode change la position horizontale du composant
 @param x La position horizontale du composant
 @since Release 1.0
*/
public void setX(int x) {
}

/**
 * Cette mthode change la position verticale du composant
 @param y La position verticale du composant
 @since Release 1.0
*/
public void setY(int y) {
}

/**
 * Cette mthode retourne une chane de caractres reprsentant l'objet.
 * Pour la classe TComponent, il s'agit des coordonnes (x, y) suivies des
 * dimensions (largeur, hauteur).
 @return string - La chane de caractre reprsentant l'objet.
 @since Release 1.0
*/
public TString toString	() {
	
	return new TString();
}
}