/*
QUSOFT MICROSYSTMES
C Object Oriented Language

Classe: TCursor - Type Cursor

Hirarchie:
TObject -> TComponent -> TCursor
*/

/**
 * La classe TCursor permet  l'utilisateur d'utiliser un curseur pour interagir
 * avec l'environnement graphique.
 @since Release 1.0
*/
public class TCursor extends TComponent {

public static final char[] DEFAULT_CURSOR;
public static final char[] DEFAULT_CURSOR_MASK;
public static final int Cursor_DEFAULT_SPEED = 4;

/**Curseur en flche*/
public static final char[] ARROW_CURSOR;

/**Masque du curseur en flche*/
public static final char[] ARROW_CURSOR_MASK;

/**Curseur en flche qui pointe vers le nord*/
public static final char[] Cursor_UP_ARROW_CURSOR;

/**Curseur en flche qui pointe vers le sud*/
public static final char[] Cursor_DOWN_ARROW_CURSOR;

/**Curseur en point*/
public static final char[] Cursor_POINT_CURSOR;

/**Curseur en sablier*/
public static final char[] Cursor_HOURGLASS_CURSOR;

/**Curseur en croix*/
public static final char[] Cursor_CROSS_CURSOR;

/**Curseur en plus*/
public static final char[] Cursor_PLUS_CURSOR;
	
	/**L'image du curseur*/
	public char[] cursor;
	/**Le masque de l'image du curseur*/
	public char[] mask;
	/**La vitesse horizontale*/
	public int speedX;
	/**La vitesse verticale*/
	public int speedY;
	/**Spcifie si le curseur est en mode XOR*/
	public boolean xor;
	/**Spcifie si il y a prsence de mnmoniques*/
	public boolean mnemonic;

/**
 * Ce constructeur instancie un objet de Type Cursor.
 @since Release 1.0
*/
public TCursor TCursor0 () {

	return new TCursor();
}

/**
 * Cette mthode retourne un objet de Type Cursor qui est une copie de l'objet.
 @return clone - Une copie de l'objet.
 @since Release 1.0
*/
public TCursor clone() {
	
	return new TCursor();
}

/**
 * Cette mthode libre l'espace mmoire occupe par l'objet, dtruisant ce dernier.
 @since Release 1.0
*/
public void finalize () {
}

/**
 * Cette mthode affiche le composant  l'cran.
 @since Release 1.0
*/
public void print() {
}

/**
 * Cette mthode permet  l'utilisateur d'utiliser le composant.
 @since Release 1.0
*/
public int use() {
	return 0;
}

/**
 * Cette mthode change l'image du cursor.
 @param cursor L'image du curseur
 @param mask L'image du masque du curseur (NULL si N/A)
 @since Release 1.0
*/
public void setCursor0(char[] cursor, char[] mask) {
}

/**
 * Cette mthode change l'image du cursor.
 @param cursor L'image du curseur
 @since Release 1.0
*/
void setCursor1(char[] cursor) {
}

/**
 * Cette mthode permet de savoir si le curseur est par dessus un composant
 * graphique particulier (cible).
 @param component0 La cible
 @return result - Vrai si le composant est par dessus
 @since Release 1.0
*/
public boolean isOver (TComponent component0) {
	
	return false;
}

/**
 * Cette mthode permet de spcifier si le curseur est en mode XOR.
 @param xor Spcifie si le curseur est en mode XOR.
 @since Release 1.0
*/
public void setXor (boolean xor) {
}
}