/*
QUSOFT MICROSYSTMES
C Object Oriented Language

Classe: TFloat - Type Float
*/

/*
	Copyrigth 2001-2002 Frdric Brown
*/

/*
    This file is part of COOL.

    COOL is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    COOL is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with COOL; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * La classe TFloat est la classe englobante du type primaire float.
 @since Release 1.0
*/

//La plus grande valeur que peut prendre un float.
#define Float_MAX_VALUE FLT_MAX

//La plus petite valeur que peut prendre un float.
#define Float_MIN_VALUE FLT_MIN

//Dclaration des mthodes
TString* Float_toString		(float);
float		 Float_parseFloat	(TString*);

/**
 * Cette mthode retourne un nombre  virgule flotante de type float converti en
 * chane de caractres.
 @param value Le nombre  convertir.
 @return string - La chane de caractre.
 @since Release 1.0
*/
TString* Float_toString(float value) {
	TString *string;
	char vec[24];
	
	sprintf(vec, "%f", value);
	
	string = TString3(vec);
	
	return string;
}

/**
 * Cette mthode convertie une chane de caractre en nombre  virgule
 * flotante de type float.
 @param paramString La chane de caractres.
 @return value - L'entier de type long.
 @since Release 1.0
*/
float Float_parseFloat(TString* string) {
	
	float value;
	TString *str = c(string);
	char c;
	int i;
	
	for (i = 0; c = str->string[i]; i++)
  {
    if (c == '-') str->string[i] = 0xAD;
    if ((c|32) == 'e') str->string[i] = 0x95;
  }
	
	value = atof(str->string);
	
	str->finalize(str);
	
	return value;
}
